   import java.awt.*;
   import java.awt.font.*;
   import java.io.*;
   import java.text.*;
   import java.awt.event.*;
   import javax.swing.*;
   import javax.swing.border.*;
   import javax.swing.table.*;
   import javax.swing.event.*;
   import java.util.Vector;
   import java.util.Properties;
   import java.util.Date;
	import java.util.*;
   import java.lang.System;
	
/**En esta seccion del programa rescatamos los datos guardados mediante properties
los cuales nos sirve para generar una lista de deudores la cual sera luego desplega sobre el
frame Deudores*/


    public class TablaDeuda extends JPanel  
   {
      Vector discos = new Vector();
      int num;
      JButton BNotificar,BAceptar;
      JTable table;
      Properties P_eventos;
      Contenido_Frame Contenido_Frame;
      String errStr;
      String NombreArchivo = new String();
      Properties Eventos = new Properties();
      FileInputStream in;            
   
       public TablaDeuda() {
         
               
         setLayout(new BorderLayout());
         String sep = String.valueOf(System.getProperty("file.separator").toCharArray()[0]);
         String dirName = null;
         
         try {
            dirName = System.getProperty("user.dir") + sep;
            System.out.print(dirName);  
         } 
             catch (SecurityException ex) {
               System.out.println(ex.toString());
               return;
            }
      
         if (dirName != null) {
            loadTabla_Botones(dirName); 
         }
         Contenido_Frame = new Contenido_Frame();
         add(Contenido_Frame);
      }
   
	
	/**cargamos los archivos a un vector*/
       public void loadTabla_Botones(String name) {
            
      
         try {
            File file = new File(name);
            String files[] = file.list();
            for (int i = 0; i < files.length; i++) {
            
               File leafFile = new File(file.getAbsolutePath(), files[i]);
               addDisco(leafFile);
            }
         }
                    
             catch (SecurityException ex) {
               reportStatus(ex.toString());
            } 
             catch (Exception ex) {
               reportStatus(ex.toString());
            }
      }
   
       private void addDisco(File file) {
         String s = file.getName().toLowerCase();
         if (s.endsWith(".prestado")){
          
            try{
               in = new FileInputStream (file);
               Eventos.load(in);
                 
            } 
                catch (FileNotFoundException e) {
                  System.err.println("\nOUTPUT FILE STREAM:\n" + e);
               } 
                catch (IOException e) {
                  System.err.println("\nOUTPUT FILE STREAM:\n" + e);
               }
         
          /**generamos el formato de fecha deseado*/
            Calendar ya = Calendar.getInstance();
            Date hoy = ya.getTime();
            
            DateFormat df = DateFormat.getDateInstance();
            //String s = df.format(prestamo);
         
                  
         //System.out.println(s);
         //String s = fecha.format(prestamo);
         	
            String ds = new String(Eventos.getProperty("Fecha"));
            try {
               Date d = df.parse(ds);
                
               if (d.before(hoy))//comapramos la fecha delos archivos con la del sistema
               {
                  discos.add(file);//si es deudor se agrega el archivo
               }
            }
                catch(ParseException e) {
                  System.out.println("Unable to parse " + ds);
               }
         }        
      }
   
       private void reportStatus(String msg) {
         if ((errStr = msg) != null) {
            System.out.println(errStr);
         }
      }
   /**genera la tabla deudor*/
       class Contenido_Frame extends JPanel implements ActionListener {
      
         TableModel dataModel;
         JFrame frame;
         JTextField textField;
         JButton applyB;
      
          public Contenido_Frame() {
            setLayout(new BorderLayout());
            setPreferredSize(new Dimension(260,300));
            setForeground(Color.RED);
            final String[] names = { "n", "Prestamos Pendientes..." };
         
            dataModel =  
                   new AbstractTableModel()
                  {
                      public int getColumnCount() { 
                        return names.length; }
                      public int getRowCount() { 
                        return discos.size();}
                      public Object getValueAt(int row, int col) { 
                        if (col == 0) {
                           return new Integer(row);
                        } 
                        else if (col == 1) {
                           Object object = discos.get(row);
                           if (object instanceof File) {
                              return ((File) object).getName();
                           } 
                        } 
                        return null;
                     }
                      public String getColumnName(int col) {
                        return names[col]; }
                      public Class getColumnClass(int c) {
                        return getValueAt(0, c).getClass();
                     }
                      public boolean isCellEditable(int row, int col) {
                        return false;
                     }
                  
                      public void setValueAt(Object aValue, int row, int col) {
                     }
                  };
         /**seteamos el aspecto de la tabla*/
            table = new JTable(dataModel);
            table.setSelectionBackground(Color.WHITE);
         	table.setBackground(Color.RED);
            TableColumn col = table.getColumn("n");
            col.setMaxWidth(20);
            table.sizeColumnsToFit(0);
         
            JScrollPane scrollPane = new JScrollPane(table);
            add(scrollPane);
         
            JPanel p1 = new JPanel();
            
                      
            BNotificar = addButton("Notificar...", p1);
            BNotificar.setToolTipText("Notificar...Atraso");
                   
            add("South", p1);
            
         }
      
          private JButton addButton(String name, JPanel p) {
            JButton b = new JButton(name);
            b.addActionListener(this);
            p.add(b);
            return b;
         }
       /**Para actualizar los datos de la tabla*/     
          public void ActualizarTabla() 
         {
            discos.clear();
            tableChanged();
            String sep = String.valueOf(System.getProperty("file.separator").toCharArray()[0]);
            String text = null;
            try
            {
               text = System.getProperty("user.dir") + sep;
            } 
                catch (SecurityException ex) {
                  reportStatus(ex.toString());
               
                  return;
               }
            loadTabla_Botones(text);
         
         }
      
          public void actionPerformed(ActionEvent e) 
         {
            Object object = e.getSource();
          
            if (object instanceof JButton) 
            {
               JButton button = (JButton) e.getSource();
              
               if (button.getText().equals("Notificar...")) 
               {
                  num = table.getSelectedRow();
                  String sep = String.valueOf(System.getProperty("file.separator").toCharArray()[0]);
                  String text = null;
                  try {
                     text = (System.getProperty("user.dir") + sep)+table.getValueAt(num , 1);;
                  } 
                      catch (SecurityException ex) {
                        System.out.println(ex.toString());
                        return;
                     }
                  
						// Aca llamar a mail.java
						
						//System.out.println(table.getValueAt(num , 1));
						String temporal = (String)table.getValueAt(num , 1);
						System.out.println(temporal);
						mail prueba = new mail();
						prueba.mailConstruye(temporal);
						prueba.show();

                  
                  File file = new File (text);
               
                  
               }
               
            }
         }
         	
          public void tableChanged()
         {
            table.tableChanged(new TableModelEvent(dataModel));
         }
            
        
      
      }  
         
   
   } 
