
   import java.awt.*;
   import java.awt.font.*;
   import java.io.*;
   import java.text.*;
   import java.awt.event.*;
   import javax.swing.*;
   import javax.swing.border.*;
   import javax.swing.table.*;
   import javax.swing.event.*;
   import java.util.Vector;
   import java.util.Properties;

/**En esta seccion del programa rescatamos los datos guardados mediante properties
los cuales nos sirve para generar una lista de prestamos la cual sera luego desplega sobre el
frame Prestamo*/
    public class TablaPrestamo extends JPanel {
   
      Vector discos = new Vector();
      int num;
      JButton BEliminar,BAceptar, BActualizar;
      JTable table;
      Properties P_eventos;
      Contenido_Frame Contenido_Frame;
      String errStr;
      String NombreArchivo =new String();
   
   
       public TablaPrestamo() {
         setLayout(new BorderLayout());
               
         setLayout(new BorderLayout());
         String sep = String.valueOf(System.getProperty("file.separator").toCharArray()[0]);
         String dirName = null;
         
         try {
            dirName = System.getProperty("user.dir") + sep;
            System.out.print(dirName);  
         } 
             catch (SecurityException ex) {
               System.out.println(ex.toString());
               return;
            }
      
      
      
         if (dirName != null) {
            loadTabla_Botones(dirName); 
         }
         Contenido_Frame = new Contenido_Frame();
         add(Contenido_Frame);
      }
   /**Cargamos los archivos a un vector todos aquellos que tengan la extension correcta*/
	       
			 public void loadTabla_Botones(String name) {
            
      
         try {
            File file = new File(name);
            String files[] = file.list();
            for (int i = 0; i < files.length; i++) {
               File leafFile = new File(file.getAbsolutePath(), files[i]);
               addDisco(leafFile);
            }
         }
                    
             catch (SecurityException ex) {
               reportStatus(ex.toString());
            } 
             catch (Exception ex) {
               reportStatus(ex.toString());
            }
      }
   
       private void addDisco(File file) {
         String s = file.getName().toLowerCase();
         if (s.endsWith(".prestado"))  discos.add(file);        
      }
   
       private void reportStatus(String msg) {
         if ((errStr = msg) != null) {
            System.out.println(errStr);
         }
      }
   
   /**Maneja el contenido de la tabla por fial y columna lo cual me permita
	poder manejar los objetos desde pantalla*/
       class Contenido_Frame extends JPanel implements ActionListener {
      
         TableModel dataModel;
         JFrame frame;
         JTextField textField;
         JButton applyB;
      
          public Contenido_Frame() {
            setLayout(new BorderLayout());
            setPreferredSize(new Dimension(260,300));
            
            final String[] names = { "n", "Prestados..." };
         
            dataModel = new AbstractTableModel()
            {
                      public int getColumnCount() { 
                        return names.length; }
                      public int getRowCount() { 
                        return discos.size();}
                      public Object getValueAt(int row, int col) { 
                        if (col == 0) {
                           return new Integer(row);
                        } 
                        else if (col == 1) {
                           Object object = discos.get(row);
                           if (object instanceof File) {
                              return ((File) object).getName();
                           } 
                        } 
                        return null;
                     }
                      public String getColumnName(int col) {
                        return names[col]; }
                      public Class getColumnClass(int c) {
                        return getValueAt(0, c).getClass();
                     }
                      public boolean isCellEditable(int row, int col) {
                        return false;
                     }
                  
                      public void setValueAt(Object aValue, int row, int col) {
                     }
                  };
         
            table = new JTable(dataModel);
            table.setSelectionForeground(Color.WHITE);
         	table.setSelectionBackground(Color.BLACK);
            TableColumn col = table.getColumn("n");
            col.setMaxWidth(20);
            table.sizeColumnsToFit(0);
         
            JScrollPane scrollPane = new JScrollPane(table);
            add(scrollPane);
         
            JPanel p1 = new JPanel();
            
            BActualizar = addButton("Actualizar", p1);
            BActualizar.setToolTipText("Actualizar...Prestamos");
           
            BEliminar = addButton("Devolucin...", p1);
            BEliminar.setToolTipText("Devolucin...Prestamos");
         	
            //BAceptar = addButton("Aceptar", p1);
            //BAceptar.setToolTipText("Enterado...de los Prestamos");
         	       
            add("South", p1);
            
         }
      
        
          private JButton addButton(String name, JPanel p) {
            JButton b = new JButton(name);
            b.addActionListener(this);
            p.add(b);
            return b;
         }
            
          public void ActualizarTabla() 
         {
            discos.clear();
            tableChanged();
            String sep = String.valueOf(System.getProperty("file.separator").toCharArray()[0]);
            String text = null;
            try
            {
               text = System.getProperty("user.dir") + sep;
            } 
                catch (SecurityException ex) {
                  reportStatus(ex.toString());
               
                  return;
               }
            loadTabla_Botones(text);
         
         }
      
          public void actionPerformed(ActionEvent e) 
         {
            Object object = e.getSource();
          
            if (object instanceof JButton) 
            {
               JButton button = (JButton) e.getSource();
              
               if (button.getText().equals("Devolucin...")) 
               {
                  num = table.getSelectedRow();
                  String sep = String.valueOf(System.getProperty("file.separator").toCharArray()[0]);
                  String text = null;
                  try {
                     text = (System.getProperty("user.dir") + sep)+table.getValueAt(num , 1);;
                  } 
                      catch (SecurityException ex) {
                        System.out.println(ex.toString());
                        return;
                     }
                  System.out.println(text);
                  
                  File file = new File (text);
                  file.delete();
                  int rows[] = table.getSelectedRows();	
                  Vector tmp = new Vector();
                  for (int i = 0; i < rows.length;i++) {
                     tmp.add(discos.get(rows[i]));
                  }
                  discos.removeAll(tmp);
                  tableChanged();
               }
               //if (button.getText().equals("Aceptar"))

               			
               if (button.getText().equals("Actualizar"))
               {
                  ActualizarTabla();}
               }
            	
         		
         }
         	
          public void tableChanged()
         {
            table.tableChanged(new TableModelEvent(dataModel));
         }
      
      }  
   
   } 
